Re: [PATCH net v4 3/3] selftests: fib_tests: Add multipath list receive tests

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



On Wed, Aug 30, 2023 at 11:13:41AM +0200, Sriram Yagnaraman wrote:
> +link_stats_get()
> +{
> +	local ns=$1; shift
> +        local dev=$1; shift
> +        local dir=$1; shift
> +        local stat=$1; shift

Indentation is off...

> +
> +        ip -n $ns -j -s link show dev $dev \
> +                | jq '.[]["stats64"]["'$dir'"]["'$stat'"]'
> +}
> +
> +list_rcv_eval()
> +{
> +	local name=$1; shift
> +	local file=$1; shift
> +	local expected=$1; shift
> +	local exp=$1; shift

Nit: You can drop the first and last arguments since they don't change
between both invocations.

> +
> +

Unnecessary blank line


> +	local count=$(tail -n 1 $file | jq '.["counter-value"] | tonumber | floor')
> +	local ratio=$(echo "scale=2; $count / $expected" | bc -l)
> +	local res=$(echo "$ratio $exp" | bc)
> +	[[ $res -eq 1 ]]
> +	log_test $? 0 "$name route hit ratio ($ratio)"
> +}
> +
> +ipv4_mpath_list_test()
> +{
> +	echo
> +	echo "IPv4 multipath list receive tests"
> +
> +	mpath_dep_check || return 1
> +
> +	route_setup
> +
> +	set -e
> +	run_cmd "ip netns exec ns1 ethtool -K veth1 tcp-segmentation-offload off"
> +
> +	run_cmd "ip netns exec ns2 bash -c \"echo 20000 > /sys/class/net/veth2/gro_flush_timeout\""
> +	run_cmd "ip netns exec ns2 bash -c \"echo 1 > /sys/class/net/veth2/napi_defer_hard_irqs\""
> +	run_cmd "ip netns exec ns2 ethtool -K veth2 generic-receive-offload on"
> +	run_cmd "ip -n ns2 link add name nh1 up type dummy"
> +	run_cmd "ip -n ns2 link add name nh2 up type dummy"
> +	run_cmd "ip -n ns2 address add 172.16.201.1/24 dev nh1"
> +	run_cmd "ip -n ns2 address add 172.16.202.1/24 dev nh2"
> +	run_cmd "ip -n ns2 neigh add 172.16.201.2 lladdr 00:11:22:33:44:55 nud perm dev nh1"
> +	run_cmd "ip -n ns2 neigh add 172.16.202.2 lladdr 00:aa:bb:cc:dd:ee nud perm dev nh2"
> +	run_cmd "ip -n ns2 route add 203.0.113.0/24
> +		nexthop via 172.16.201.2 nexthop via 172.16.202.2"
> +	run_cmd "ip netns exec ns2 sysctl -qw net.ipv4.fib_multipath_hash_policy=1"
> +	set +e
> +
> +	local dmac=$(ip -n ns2 -j link show dev veth2 | jq -r '.[]["address"]')
> +	local tmp_file=$(mktemp)
> +	local cmd="ip netns exec ns1 mausezahn veth1 -a own -b $dmac
> +		-A 172.16.101.1 -B 203.0.113.1 -t udp 'sp=12345,dp=0-65535' -q"
> +
> +	# Packets forwarded in a list using a multipath route must not reuse a
> +	# cached result so that a flow always hits the same nexthop. In other
> +	# words, the FIB lookup tracepoint needs to be triggered for every
> +	# packet.
> +	local t0_rx_pkts=$(link_stats_get ns2 veth2 rx packets)
> +	run_cmd "perf stat -e fib:fib_table_lookup --filter 'err == 0' -j -o $tmp_file -- $cmd"
> +	local t1_rx_pkts=$(link_stats_get ns2 veth2 rx packets)
> +	local diff=$(echo $t1_rx_pkts - $t0_rx_pkts | bc -l)
> +	list_rcv_eval "Multipath" $tmp_file $diff ">= 0.95"
> +
> +	rm $tmp_file
> +	route_cleanup
> +}
> +
> +ipv6_mpath_list_test()
> +{
> +	echo
> +	echo "IPv6 multipath list receive tests"
> +
> +	mpath_dep_check || return 1
> +
> +	route_setup
> +
> +	set -e
> +	run_cmd "ip netns exec ns1 ethtool -K veth1 tcp-segmentation-offload off"
> +
> +	run_cmd "ip netns exec ns2 bash -c \"echo 20000 > /sys/class/net/veth2/gro_flush_timeout\""
> +	run_cmd "ip netns exec ns2 bash -c \"echo 1 > /sys/class/net/veth2/napi_defer_hard_irqs\""
> +	run_cmd "ip netns exec ns2 ethtool -K veth2 generic-receive-offload on"
> +	run_cmd "ip -n ns2 link add name nh1 up type dummy"
> +	run_cmd "ip -n ns2 link add name nh2 up type dummy"
> +	run_cmd "ip -n ns2 -6 address add 2001:db8:201::1/64 dev nh1"
> +	run_cmd "ip -n ns2 -6 address add 2001:db8:202::1/64 dev nh2"
> +	run_cmd "ip -n ns2 -6 neigh add 2001:db8:201::2 lladdr 00:11:22:33:44:55 nud perm dev nh1"
> +	run_cmd "ip -n ns2 -6 neigh add 2001:db8:202::2 lladdr 00:aa:bb:cc:dd:ee nud perm dev nh2"
> +	run_cmd "ip -n ns2 -6 route add 2001:db8:301::/64
> +		nexthop via 2001:db8:201::2 nexthop via 2001:db8:202::2"
> +	run_cmd "ip netns exec ns2 sysctl -qw net.ipv6.fib_multipath_hash_policy=1"
> +	set +e
> +
> +	local dmac=$(ip -n ns2 -j link show dev veth2 | jq -r '.[]["address"]')
> +	local tmp_file=$(mktemp)
> +	local cmd="ip netns exec ns1 mausezahn -6 veth1 -a own -b $dmac
> +		-A 2001:db8:101::1 -B 2001:db8:301::1 -t udp 'sp=12345,dp=0-65535' -q"
> +
> +	# Packets forwarded in a list using a multipath route must not reuse a
> +	# cached result so that a flow always hits the same nexthop. In other
> +	# words, the FIB lookup tracepoint needs to be triggered for every
> +	# packet.
> +	local t0_rx_pkts=$(link_stats_get ns2 veth2 rx packets)
> +	run_cmd "perf stat -e fib6:fib6_table_lookup --filter 'err == 0' -j -o $tmp_file -- $cmd"
> +	local t1_rx_pkts=$(link_stats_get ns2 veth2 rx packets)
> +	local diff=$(echo $t1_rx_pkts - $t0_rx_pkts | bc -l)
> +	list_rcv_eval "Multipath" $tmp_file $diff ">= 0.95"
> +
> +	rm $tmp_file
> +	route_cleanup
> +}
> +
>  ################################################################################
>  # usage
>  
> @@ -2433,6 +2587,8 @@ do
>  	ipv6_mangle)			ipv6_mangle_test;;
>  	ipv4_bcast_neigh)		ipv4_bcast_neigh_test;;
>  	fib6_gc_test|ipv6_gc)		fib6_gc_test;;
> +	ipv4_mpath_list)		ipv4_mpath_list_test;;
> +	ipv6_mpath_list)		ipv6_mpath_list_test;;
>  
>  	help) echo "Test names: $TESTS"; exit 0;;
>  	esac
> -- 
> 2.34.1
> 
> 



[Index of Archives]     [Linux Wireless]     [Linux Kernel]     [ATH6KL]     [Linux Bluetooth]     [Linux Netdev]     [Kernel Newbies]     [Share Photos]     [IDE]     [Security]     [Git]     [Netfilter]     [Bugtraq]     [Yosemite News]     [MIPS Linux]     [ARM Linux]     [Linux Security]     [Linux RAID]     [Linux ATA RAID]     [Samba]     [Device Mapper]

  Powered by Linux